unit NestedTables;

interface

uses
{$IFDEF LINUX}
  SysUtils, Types, Classes, QGraphics, QControls, QForms, QDialogs, QStdCtrls,
  QDBCtrls, QComCtrls, QExtCtrls, QGrids, QDBGrids, QButtons, OdacClx,
{$ELSE}
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DBCtrls, ExtCtrls, Grids, DBGrids, StdCtrls, ToolWin, ComCtrls, Buttons,
  OdacVcl,
{$ENDIF}
  Db, DBAccess, Ora, OraScript, OraSmart, MemDS, OdacDemoFrame, OdacDemoForm,
  DAScript;

type
  TNestedTablesFrame = class(TOdacDemoFrame)
    DataSource1: TDataSource;
    DataSource2: TDataSource;
    OraNestedTable: TOraNestedTable;
    Query: TSmartQuery;
    sqGet: TOraSQL;
    OraNestedTable1: TOraNestedTable;
    DataSource3: TDataSource;
    sqAppend: TOraSQL;
    sqUpdate: TOraSQL;
    QueryCODE: TFloatField;
    QueryCONTENT: TOraDataSetField;
    QueryROWID: TStringField;
    Panel6: TPanel;
    Panel4: TPanel;
    DBGrid1: TDBGrid;
    Panel5: TPanel;
    DBGrid2: TDBGrid;
    Splitter1: TSplitter;
    Panel7: TPanel;
    DBGrid3: TDBGrid;
    Panel10: TPanel;
    Panel3: TPanel;
    btOpenTable: TSpeedButton;
    btCloseTable: TSpeedButton;
    DBNavigator3: TDBNavigator;
    Splitter2: TSplitter;
    Panel11: TPanel;
    Panel1: TPanel;
    btOpenNested: TSpeedButton;
    btCloseNested: TSpeedButton;
    DBNavigator2: TDBNavigator;
    Panel12: TPanel;
    Panel2: TPanel;
    btOpen: TSpeedButton;
    btClose: TSpeedButton;
    DBNavigator1: TDBNavigator;
    btGetTable: TSpeedButton;
    btAppendTable: TSpeedButton;
    btImportTable: TSpeedButton;
    btUpdateTable: TSpeedButton;
    procedure btOpenClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure btGetTableClick(Sender: TObject);
    procedure btAppendTableClick(Sender: TObject);
    procedure btUpdateTableClick(Sender: TObject);
    procedure btOpenNestedClick(Sender: TObject);
    procedure btCloseNestedClick(Sender: TObject);
    procedure btOpenTableClick(Sender: TObject);
    procedure btCloseTableClick(Sender: TObject);
    procedure btImportTableClick(Sender: TObject);
  private
    { Private declarations }
  public
    procedure Initialize; override;
    procedure SetDebug(Value: boolean); override;
  end;

implementation
uses
  OraObjects;

{$IFNDEF FPC}
{$IFDEF CLR}
{$R *.nfm}
{$ELSE}
{$R *.dfm}
{$ENDIF}
{$ENDIF}

procedure TNestedTablesFrame.btOpenClick(Sender: TObject);
begin
  Query.Open;
  //if not Query.IsEmpty then
    OraNestedTable.Open;
end;

procedure TNestedTablesFrame.btCloseClick(Sender: TObject);
begin
  Query.Close;
end;

procedure TNestedTablesFrame.btGetTableClick(Sender: TObject);
begin
  if not Query.EOF then begin
    sqGet.ParamByName('Code').AsInteger:= Query.FieldByName('Code').AsInteger;
    sqGet.ParamByName('Res').AsTable.CreateObject(OdacForm.OraSession.OCISvcCtx, 'TODACNestedTable');
    sqGet.Execute;
    OraNestedTable1.Table:= sqGet.ParamByName('Res').AsTable;
    OraNestedTable1.Open;
  end;
end;

procedure TNestedTablesFrame.btAppendTableClick(Sender: TObject);
begin
  sqAppend.ParamByName('Value').AsTable:= OraNestedTable1.Table;
  sqAppend.Execute;
end;

procedure TNestedTablesFrame.btUpdateTableClick(Sender: TObject);
begin
  if not Query.EOF then begin
    sqUpdate.ParamByName('Code').AsInteger:= Query.FieldByName('Code').AsInteger;
    sqUpdate.ParamByName('Value').AsTable:= OraNestedTable1.Table;
    sqUpdate.Execute;
  end;
end;

procedure TNestedTablesFrame.btOpenNestedClick(Sender: TObject);
begin
  OraNestedTable.Open;
end;

procedure TNestedTablesFrame.btCloseNestedClick(Sender: TObject);
begin
  OraNestedTable.Close;
end;

procedure TNestedTablesFrame.btOpenTableClick(Sender: TObject);
begin
  OraNestedTable1.Open;
end;

procedure TNestedTablesFrame.btCloseTableClick(Sender: TObject);
begin
  OraNestedTable1.Close;
end;

procedure TNestedTablesFrame.btImportTableClick(Sender: TObject);
begin
  OraNestedTable1.Table:= Query.GetTable('Content');
  OraNestedTable1.Open;
end;

procedure TNestedTablesFrame.Initialize;
begin
  inherited;

  Query.Connection := Connection;
end;

procedure TNestedTablesFrame.SetDebug(Value: boolean);
begin
  Query.Debug := Value;
end;

end.
 